> ## Documentation Index
> Fetch the complete documentation index at: https://developers.telnyx.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Get all SIM cards

> Get all SIM cards belonging to the user that match the given filters.



## OpenAPI

````yaml https://telnyx-openapi-ng.s3.us-east-1.amazonaws.com/wireless/sim-cards.yml get /sim_cards
openapi: 3.1.0
info:
  title: SIM Cards API
  version: 2.0.0
  description: >-
    Basic SIM card management including listing, creating, retrieving, updating,
    and deleting SIM cards.
  contact:
    email: support@telnyx.com
servers:
  - url: https://api.telnyx.com/v2
security:
  - bearerAuth: []
paths:
  /sim_cards:
    get:
      tags:
        - SIM Cards
      summary: Get all SIM cards
      description: Get all SIM cards belonging to the user that match the given filters.
      operationId: GetSimCards
      parameters:
        - $ref: '#/components/parameters/FilterSIMCardConsolidated'
        - $ref: '#/components/parameters/wireless_PageConsolidated'
        - $ref: '#/components/parameters/IncludeSIMCardGroup'
        - $ref: '#/components/parameters/FilterSIMCardGroupId'
        - name: sort
          description: >-
            Sorts SIM cards by the given field. Defaults to ascending order
            unless field is prefixed with a minus sign.
          in: query
          required: false
          example: '-current_billing_period_consumed_data.amount'
          schema:
            type: string
            enum:
              - current_billing_period_consumed_data.amount
              - '-current_billing_period_consumed_data.amount'
      responses:
        '200':
          $ref: '#/components/responses/SearchSimCardsResponse'
        '401':
          description: Unauthorized
        default:
          $ref: '#/components/responses/wireless_GenericErrorResponse'
      x-codeSamples:
        - lang: JavaScript
          source: |-
            import Telnyx from 'telnyx';

            const client = new Telnyx({
              apiKey: process.env['TELNYX_API_KEY'], // This is the default and can be omitted
            });

            // Automatically fetches more pages as needed.
            for await (const simpleSimCard of client.simCards.list()) {
              console.log(simpleSimCard.id);
            }
        - lang: Python
          source: |-
            import os
            from telnyx import Telnyx

            client = Telnyx(
                api_key=os.environ.get("TELNYX_API_KEY"),  # This is the default and can be omitted
            )
            page = client.sim_cards.list()
            page = page.data[0]
            print(page.id)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/team-telnyx/telnyx-go\"\n\t\"github.com/team-telnyx/telnyx-go/option\"\n)\n\nfunc main() {\n\tclient := telnyx.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tpage, err := client.SimCards.List(context.TODO(), telnyx.SimCardListParams{})\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", page)\n}\n"
        - lang: Java
          source: |-
            package com.telnyx.sdk.example;

            import com.telnyx.sdk.client.TelnyxClient;
            import com.telnyx.sdk.client.okhttp.TelnyxOkHttpClient;
            import com.telnyx.sdk.models.simcards.SimCardListPage;
            import com.telnyx.sdk.models.simcards.SimCardListParams;

            public final class Main {
                private Main() {}

                public static void main(String[] args) {
                    TelnyxClient client = TelnyxOkHttpClient.fromEnv();

                    SimCardListPage page = client.simCards().list();
                }
            }
        - lang: Ruby
          source: |-
            require "telnyx"

            telnyx = Telnyx::Client.new(api_key: "My API Key")

            page = telnyx.sim_cards.list

            puts(page)
        - lang: CLI
          source: |-
            telnyx sim-cards list \
              --api-key 'My API Key'
components:
  parameters:
    FilterSIMCardConsolidated:
      name: filter
      in: query
      explode: true
      description: >-
        Consolidated filter parameter for SIM cards (deepObject style).
        Originally: filter[iccid], filter[msisdn], filter[status], filter[tags]
      schema:
        type: object
        properties:
          iccid:
            type: string
            example: '89310410106543789301'
            description: A search string to partially match for the SIM card's ICCID.
          msisdn:
            type: string
            example: '+13109976224'
            description: A search string to match for the SIM card's MSISDN.
          status:
            type: array
            items:
              type: string
              enum:
                - enabled
                - disabled
                - standby
                - data_limit_exceeded
                - unauthorized_imei
            description: Filter by a SIM card's status.
          tags:
            type: array
            items:
              type: string
            example:
              - personal
              - customers
              - active-customers
            description: >
              A list of SIM card tags to filter on.<br/><br/>
               If the SIM card contains <b><i>all</i></b> of the given <code>tags</code> they will be found.<br/><br/>
              For example, if the SIM cards have the following tags: <ul>
                <li><code>['customers', 'staff', 'test']</code>
                <li><code>['test']</code></li>
                <li><code>['customers']</code></li>
              </ul>

              Searching for <code>['customers', 'test']</code> returns only the
              first because it's the only one with both tags.<br/> Searching for
              <code>test</code> returns the first two SIMs, because both of them
              have such tag.<br/> Searching for <code>customers</code> returns
              the first and last SIMs.<br/>
    wireless_PageConsolidated:
      name: page
      in: query
      explode: true
      description: >-
        Consolidated pagination parameter (deepObject style). Originally:
        page[number], page[size]
      schema:
        type: object
        properties:
          number:
            type: integer
            minimum: 1
            default: 1
            description: The page number to load.
          size:
            type: integer
            minimum: 1
            maximum: 250
            default: 20
            description: The size of the page.
    IncludeSIMCardGroup:
      name: include_sim_card_group
      in: query
      description: >-
        It includes the associated SIM card group object in the response when
        present.
      schema:
        type: boolean
        default: false
        example: true
    FilterSIMCardGroupId:
      name: filter[sim_card_group_id]
      description: A valid SIM card group ID.
      schema:
        format: uuid
        type: string
        example: 47a1c2b0-cc7b-4ab1-bb98-b33fb0fc61b9
      in: query
  responses:
    SearchSimCardsResponse:
      description: Successful response
      content:
        application/json:
          schema:
            type: object
            properties:
              data:
                type: array
                items:
                  $ref: '#/components/schemas/SimpleSIMCard'
              meta:
                $ref: '#/components/schemas/PaginationMeta'
    wireless_GenericErrorResponse:
      description: Unexpected error
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/wireless_Errors'
  schemas:
    SimpleSIMCard:
      type: object
      title: SIMCard
      properties:
        id:
          type: string
          format: uuid
          description: Identifies the resource.
          readOnly: true
          example: 6a09cdc3-8948-47f0-aa62-74ac943d6c58
        record_type:
          type: string
          example: sim_card
          readOnly: true
        status:
          $ref: '#/components/schemas/SIMCardStatus'
        type:
          type: string
          description: The type of SIM card
          readOnly: true
          example: physical
          enum:
            - physical
            - esim
        iccid:
          type: string
          description: >
            The ICCID is the identifier of the specific SIM card/chip. Each SIM
            is internationally identified by its integrated circuit card
            identifier (ICCID). ICCIDs are stored in the SIM card's memory and
            are also engraved or printed on the SIM card body during a process
            called personalization.
          readOnly: true
          example: '89310410106543789301'
        imsi:
          type: string
          description: >
            SIM cards are identified on their individual network operators by a
            unique International Mobile Subscriber Identity (IMSI). <br/>

            Mobile network operators connect mobile phone calls and communicate
            with their market SIM cards using their IMSIs. The IMSI is stored in
            the Subscriber  Identity Module (SIM) inside the device and is sent
            by the device to the appropriate network. It is used to acquire the
            details of the device in the Home  Location Register (HLR) or the
            Visitor Location Register (VLR).
          readOnly: true
          example: '081932214823362973'
        msisdn:
          type: string
          description: >
            Mobile Station International Subscriber Directory Number (MSISDN) is
            a number used to identify a mobile phone number internationally.
            <br/>

            MSISDN is defined by the E.164 numbering plan. It includes a country
            code and a National Destination Code which identifies the
            subscriber's operator.
          readOnly: true
          example: '+13109976224'
        sim_card_group_id:
          type: string
          format: uuid
          description: >-
            The group SIMCardGroup identification. This attribute can be
            <code>null</code> when it's present in an associated resource.
          example: 6a09cdc3-8948-47f0-aa62-74ac943d6c58
        tags:
          type: array
          description: Searchable tags associated with the SIM card
          items:
            type: string
          example:
            - personal
            - customers
            - active-customers
        data_limit:
          type: object
          description: The SIM card individual data limit configuration.
          readOnly: true
          properties:
            amount:
              type: string
              example: '2048.0'
            unit:
              type: string
              example: MB
              enum:
                - MB
                - GB
        current_billing_period_consumed_data:
          type: object
          description: The SIM card consumption so far in the current billing cycle.
          readOnly: true
          properties:
            amount:
              type: string
              example: '2049.0'
            unit:
              type: string
              example: MB
              default: MB
        actions_in_progress:
          type: boolean
          description: Indicate whether the SIM card has any pending (in-progress) actions.
          readOnly: true
          example: true
          default: false
        created_at:
          type: string
          description: >-
            ISO 8601 formatted date-time indicating when the resource was
            created.
          readOnly: true
          example: '2018-02-02T22:25:27.521Z'
        updated_at:
          type: string
          description: >-
            ISO 8601 formatted date-time indicating when the resource was
            updated.
          readOnly: true
          example: '2018-02-02T22:25:27.521Z'
        esim_installation_status:
          type:
            - string
            - 'null'
          description: The installation status of the eSIM. Only applicable for eSIM cards.
          readOnly: true
          example: released
          enum:
            - released
            - disabled
        version:
          type: string
          description: The version of the SIM card.
          readOnly: true
          example: '4.3'
        resources_with_in_progress_actions:
          type: array
          description: List of resources with actions in progress.
          readOnly: true
          items:
            type: object
          example: []
        eid:
          type:
            - string
            - 'null'
          description: The Embedded Identity Document (eID) for eSIM cards.
          readOnly: true
          example: null
        authorized_imeis:
          type:
            - array
            - 'null'
          description: List of IMEIs authorized to use a given SIM card.
          items:
            type: string
          example:
            - '106516771852751'
            - '534051870479563'
            - '508821468377961'
        voice_enabled:
          type: boolean
          description: Indicates whether voice services are enabled for the SIM card.
          readOnly: true
          example: false
          default: false
    PaginationMeta:
      type: object
      properties:
        total_pages:
          type: integer
          example: 3
        total_results:
          type: integer
          example: 55
        page_number:
          type: integer
          example: 2
        page_size:
          type: integer
          example: 25
    wireless_Errors:
      properties:
        errors:
          type: array
          items:
            $ref: '#/components/schemas/wireless_Error'
      type: object
    SIMCardStatus:
      type: object
      properties:
        value:
          type: string
          enum:
            - registering
            - enabling
            - enabled
            - disabling
            - disabled
            - data_limit_exceeded
            - setting_standby
            - standby
          description: >
            The current status of the SIM card. It will be one of the following:
            <br/>

            <ul>
             <li><code>registering</code> - the card is being registered</li>
             <li><code>enabling</code> - the card is being enabled</li>
             <li><code>enabled</code> - the card is enabled and ready for use</li>
             <li><code>disabling</code> - the card is being disabled</li>
             <li><code>disabled</code> - the card has been disabled and cannot be used</li>
             <li><code>data_limit_exceeded</code> - the card has exceeded its data consumption limit</li>
             <li><code>setting_standby</code> - the process to set the card in stand by is in progress</li>
             <li><code>standby</code> - the card is in stand by</li>
            </ul>

            Transitioning between the enabled and disabled states may take a
            period of time.
          readOnly: true
          example: enabled
        reason:
          type: string
          description: It describes why the SIM card is in the current status.
          readOnly: true
          example: >-
            The SIM card is active, ready to connect to networks and consume
            data.
    wireless_Error:
      required:
        - code
        - title
      properties:
        code:
          type: string
        title:
          type: string
        detail:
          type: string
        source:
          type: object
          properties:
            pointer:
              description: JSON pointer (RFC6901) to the offending entity.
              type: string
            parameter:
              description: Indicates which query parameter caused the error.
              type: string
        meta:
          type: object
          additionalProperties: true
      type: object
  securitySchemes:
    bearerAuth:
      scheme: bearer
      type: http

````